#include "orbitervisualizer.hpp"

OrbiterVisualizer::OrbiterVisualizer(Orbiter& orbiter, Icosphere& sphere, GLuint shaderProgram)
    : _orbiter(orbiter), _sphere(sphere), _widget(shaderProgram)
{
}

void OrbiterVisualizer::render(float time)
{
    const Orbit& orbit = _orbiter.getOrbit();

    const float meanAnomaly = time;
    glm::vec3 pos = orbit.getPosition(meanAnomaly);

    // render widget
    glm::mat4 widgetMatrix = orbit.getLookAlongMatrix(time);
    _widget.setModelMatrix(widgetMatrix);
    _widget.render(time);

    // render sphere
    _sphere.setPosition(pos);
    _sphere.render(time);
}
